  
 /* 
    
'||'''|. |''||''| '\\  //`   ||                   
 ||   ||    ||      \\//     ||                   
 ||   ||    ||       ||    ''||''   '''|.  '||''| 
 ||   ||    ||       ||      ||    .|''||   ||    
.||...|' |..||..|   .||.     `|..' `|..||. .||.   
*/



#define ShiftLed 13

#define potPin1  4
#define potPin2  5

#define usesMidi 1
#define debugprint 0

/**/

//Pin connected to ST_CP of 74HC595, pin 12 on chip
#include "WProgram.h"
void setup_button();
void changeOn(int i);
int readKey(int i);
void populate_buttons();
void printButtons();
void transMitButtonsToSM();
void shiftOut(int myDataPin, int myClockPin, byte myDataOut);
void setup_ButtonStates();
void updateState(int nr,byte inState);
int getNextUnhandeledKeyPress();
byte getVelocityForKey(int nr);
int getNextUnhandeledKeyRelease();
void settime(int nr,byte in_onOff);
void run_guitarHeroMode();
int checkSoftpot1();
int checkSoftpot2();
void run_guitarMode();
void setup();
void loop();
void sendMidiMessage(char cmd, char data1, char data2);
void setup_midi();
void setup_shiftButton();
void checkShiftButton();
void run_shiftMode();
void setup_softpots();
void populate_softpots();
void printpots();
void run_testMode();
int latchPin = 4;
//Pin connected to SH_CP of 74HC595, pin 11 on chip
int clockPin = 3;
////Pin connected to DS of 74HC595, 14 on chip 
int dataPin =5;



int RootNote = 36-4  ; //first not that we read on the matrix is nr 4, thus the -4
//int mode = 10; //testMode
int mode = 0; //guitarmode
int program =0;



boolean isShift = false;
boolean isWaitingForUp = false;
int shiftPin = 2;    

int SoftPot1 = 0;       // variable to store the value coming from the sensor
int SoftPot2 = 0;       // variable to store the value coming from the sensor





 


 


int inPin[8] = {  
  7,6,14,12,11,10,9,8  };

byte dataArray[8];

byte tempButtons[64];


void setup_button()
{

  //set pins to output because they are addressed in the main loop
  pinMode(latchPin, OUTPUT);


  dataArray[0] = B11011111; //
  dataArray[1] = B10111111;     //B10111111
  dataArray[2] = B11111101; //
  dataArray[3] = B11111011; //


  dataArray[4] = B11101111; //
  dataArray[5] = B01111111;       //B01111111
  dataArray[6] = B11111110; //
  dataArray[7] = B11110111; //




  for (int i = 0; i < 8; i++)   
  {
    pinMode(inPin[i], INPUT);
    pinMode(inPin[i], HIGH);
  }

}


void changeOn(int i)
{
  digitalWrite(latchPin, 0);
  shiftOut(dataPin, clockPin, dataArray[i]);   
  digitalWrite(latchPin, 1);

}

int readKey(int i)
{
  int val;
  pinMode(inPin[i], LOW);
  val=digitalRead(inPin[i]);

  pinMode(inPin[i], HIGH);
  return val;

}
void populate_buttons()
{
  int arne =0;
  for (int j = 0; j < 8; j++) 
  {
    changeOn(j);
  
    for (int i = 0; i < 8; i++)
    {
      int val;
      val = readKey(i);
      tempButtons[arne]=val;
      arne++;
    } 
  }


}

void printButtons()
{
  #if debugprint
  for(int i=0 ; i < 64 ; i++)
  {
    Serial.print(tempButtons[i],DEC);  
  }
  Serial.println("");    
  #endif

}

void transMitButtonsToSM()
{
  for(int i=0 ; i < 64 ; i++)
  {
    settime(i,tempButtons[i]);
  }
}

// the heart of the program
void shiftOut(int myDataPin, int myClockPin, byte myDataOut) {
  // This shifts 8 bits out MSB first, 
  //on the rising edge of the clock,
  //clock idles low

  //internal function setup
  int i=0;
  int pinState;
  pinMode(myClockPin, OUTPUT);
  pinMode(myDataPin, OUTPUT);

  //clear everything out just in case to
  //prepare shift register for bit shifting
  digitalWrite(myDataPin, 0);
  digitalWrite(myClockPin, 0);

  //for each bit in the byte myDataOut?
  //NOTICE THAT WE ARE COUNTING DOWN in our for loop
  //This means that %00000001 or "1" will go through such
  //that it will be pin Q0 that lights. 
  for (i=7; i>=0; i--)  {
    digitalWrite(myClockPin, 0);

    //if the value passed to myDataOut and a bitmask result 
    // true then... so if we are at i=6 and our value is
    // %11010100 it would the code compares it to %01000000 
    // and proceeds to set pinState to 1.
    if ( myDataOut & (1<<i) ) {
      pinState= 1;
    }
    else {	
      pinState= 0;
    }

    //Sets the pin to HIGH or LOW depending on pinState
    digitalWrite(myDataPin, pinState);
    //register shifts bits on upstroke of clock pin  
    digitalWrite(myClockPin, 1);
    //zero the data pin after shift to prevent bleed through
    digitalWrite(myDataPin, 0);
  }

  //stop shifting
  digitalWrite(myClockPin, 0);
}





#define IN_STATE_BR_PRESSED 1
#define IN_STATE_MR_PRESSED 2
#define IN_STATE_BR_RELELEASED 3
#define IN_STATE_MR_RELELEASED 4


#define STATE_INIT 0
#define STATE_WAITING_FOR_MR 1
#define STATE_WAITING_FOR_BR 2
#define STATE_HAS_VELOCITY 4
#define STATE_PRESSED 3
#define STATE_RELEASED 5




/* you can press the tangent and then you get first one down, then next down. when both are down you should get a velocity*/



struct buttonState
{
  long BR;
  long MR;   
  byte Velocity;
  byte State;
} 
;

buttonState buttonStates[33];

void setup_ButtonStates()
{
  for (int i=0;i<32;i++)
  {
    buttonStates[i].BR=millis();
    buttonStates[i].MR=millis();
    buttonStates[i].Velocity=0;
    buttonStates[i].State = STATE_INIT;
  }
}

void updateState(int nr,byte inState)
{
  //---------- Pressed
  if(inState == IN_STATE_BR_PRESSED)
    if(buttonStates[nr].State==STATE_INIT)
    {
      buttonStates[nr].BR=millis();
 //     Serial.print("setting BR to ");
 //     Serial.println(buttonStates[nr].BR);
  
      buttonStates[nr].State=STATE_WAITING_FOR_MR;
  //    Serial.println("setting state to STATE_WAITING_FOR_MR");
    }    
  

  if(inState == IN_STATE_MR_PRESSED )
    if(buttonStates[nr].State==STATE_WAITING_FOR_MR)
    {
      
       buttonStates[nr].MR=millis();
 //     Serial.print("setting MR to ");
 //     Serial.println(buttonStates[nr].MR);

      
      buttonStates[nr].Velocity=127-(buttonStates[nr].MR-buttonStates[nr].BR);
      if(buttonStates[nr].Velocity <= 0)
        buttonStates[nr].Velocity=1;
      if(buttonStates[nr].Velocity >= 127) //took waaaay to long time
        buttonStates[nr].Velocity=1;
        
      
      buttonStates[nr].State=STATE_HAS_VELOCITY;  
      //Serial.println("setting state to STATE_HAS_VELOCITY");
      //Serial.println("has velociy");
    /*  Serial.print("Millis: ");
      Serial.print(buttonStates[nr].BR);
      Serial.print(" ");
      Serial.print(buttonStates[nr].MR);
      Serial.print(" ");
      Serial.print(buttonStates[nr].Velocity,DEC);
      Serial.println();*/
      
    }
  //---------- EndPressed

  //---------- RELEASE
  if(buttonStates[nr].State==STATE_PRESSED)
    if(inState == IN_STATE_MR_RELELEASED)
{
  buttonStates[nr].State=STATE_WAITING_FOR_BR;
    //Serial.println("setting state to STATE_WAITING_FOR_BR");
}
  if(inState == IN_STATE_BR_RELELEASED )
    if( buttonStates[nr].State==STATE_WAITING_FOR_BR)
    {
      buttonStates[nr].State=STATE_RELEASED;  
    //  Serial.println("setting state to STATE_RELEASED");
    }
  //---------- EndRELEASE
}



int getNextUnhandeledKeyPress()
{
  for (int i=0;i<=32;i++)
    if(buttonStates[i].State ==STATE_HAS_VELOCITY)
    {
 //     Serial.print(i,DEC);
   //   Serial.println("knas");
      return i;
    }
  return -1;
}

byte getVelocityForKey(int nr)
{
  buttonStates[nr].State=STATE_PRESSED;
  //Serial.println("setting state to STATE_PRESSED");
  //Serial.print(nr,DEC);
  //Serial.println(" getting velocity");
  return buttonStates[nr].Velocity;
}

int getNextUnhandeledKeyRelease()
{
  for (int i=0;i<32;i++)
    if(buttonStates[i].State ==STATE_RELEASED)
    {
      buttonStates[i].State=STATE_INIT;
    //  Serial.println("setting state to STATE_INIT");
    //  Serial.println("getting key release");
      return i;
    }
  //Serial.println("getting No key release");
  return -1;
}

void settime(int nr,byte in_onOff)
{

  if(nr<=32)
  {
    if( in_onOff == 0)
    {
      updateState(nr,IN_STATE_BR_PRESSED);
    }
    else
    {
      buttonStates[nr].BR=0;
      updateState(nr,IN_STATE_BR_RELELEASED);
    }
  }
  else
  {
    if( in_onOff == 0)
    {
      updateState(nr-32,IN_STATE_MR_PRESSED);
    }
    else
    {
      buttonStates[nr-32].MR=0;
      updateState(nr-32,IN_STATE_MR_RELELEASED);
    }
  }


}


int GHoldSoftpot1=-1;
int GHoldSoftpot2=-1;




#define NUM_DIV 70



void run_guitarHeroMode()
{
  int key;
  int internalRootNote = (RootNote+14);

  key=getNextUnhandeledKeyPress();

  while(key!=-1)
  {  
    if(key==16)
    {
      GHoldSoftpot1 = SoftPot1/NUM_DIV;
      sendMidiMessage(0x90,  (internalRootNote-GHoldSoftpot1)+12,getVelocityForKey(key));
#if debugprint
      Serial.print("GHoldSoftpot1 Turning on note ");
      Serial.println(GHoldSoftpot1);
#endif
    }
    if(key==18)
    {
      GHoldSoftpot2 = SoftPot2/NUM_DIV;
      sendMidiMessage(0x90, internalRootNote-GHoldSoftpot2,getVelocityForKey(key));
#if debugprint
      Serial.print("GHoldSoftpot2 Turning on note ");
      Serial.println(GHoldSoftpot2);
#endif
    }
    else
    {
      getVelocityForKey(key);
    }

    key=getNextUnhandeledKeyPress();  
  }

  key=getNextUnhandeledKeyRelease();
  while(key!=-1)
  {  
    if(key==16)
    {
      sendMidiMessage(0x80, (internalRootNote-GHoldSoftpot1)+12,0x00);
#if debugprint
      Serial.print("GHoldSoftpot1 Turning of note ");
      Serial.println(GHoldSoftpot1);
#endif

    }
    if(key==18)
    {
      sendMidiMessage(0x80,internalRootNote-GHoldSoftpot2,0x00);
#if debugprint
      Serial.print("GHoldSoftpot2 Turning of note ");
      Serial.println(GHoldSoftpot2);
#endif
    }
    key=getNextUnhandeledKeyRelease();

  }

}


int oldSoftpot1=1024;
int oldSoftpot2=1024;
boolean softpot1waspressed = true;
boolean softpot2waspressed = true;

#define NUM_DIV 70


int checkSoftpot1()
{
  if(SoftPot1 > 1010)
  {
    if(softpot1waspressed==true)
    {
#if debugprint
      Serial.print("Softpot1 Turning off note ");
      Serial.println(oldSoftpot1);
#endif 
      sendMidiMessage(0x80, (RootNote-oldSoftpot1)+36,0);  
      softpot1waspressed = false;
      SoftPot1 = SoftPot1/NUM_DIV;
      oldSoftpot1=SoftPot1;
      return 1;
    }
  }

  SoftPot1 = SoftPot1/NUM_DIV;

  if(SoftPot1!=oldSoftpot1)
    if(softpot1waspressed==false)
    { 
#if debugprint
      Serial.print("Softpot1 turning on Note: ");
      Serial.println(SoftPot1);
#endif
      oldSoftpot1=SoftPot1;
      sendMidiMessage(0x90,(RootNote-SoftPot1)+36,0x110); 
      softpot1waspressed = true;

    }

  return 1;

}



int checkSoftpot2()
{
  if(SoftPot2 > 1020)
  {
    if(softpot2waspressed==true)
    {
#if debugprint
      Serial.print("Softpot2 Turning off note ");
      Serial.println(oldSoftpot2);
#endif 
      sendMidiMessage(0x80, (RootNote-oldSoftpot2)+24,0);  
      softpot2waspressed = false;
      SoftPot2 = SoftPot2/NUM_DIV;
      oldSoftpot2=SoftPot2;
      return 1;
    }
  }

  SoftPot2 = SoftPot2/NUM_DIV;

  if(SoftPot2!=oldSoftpot2)
    if(softpot2waspressed==false)
    { 
#if debugprint
      Serial.print("Softpot2 turning on Note: ");
      Serial.println(SoftPot2);
#endif
      oldSoftpot2=SoftPot2;
      sendMidiMessage(0x90,(RootNote-SoftPot2)+24,0x110); 
      softpot2waspressed = true;

    }

  return 1;

}

void run_guitarMode()
{
  int key;

  checkSoftpot2();
  checkSoftpot1();

  key=getNextUnhandeledKeyPress();
  while(key!=-1)
  {  
    sendMidiMessage(0x90, RootNote+key,getVelocityForKey(key));
    key=getNextUnhandeledKeyPress();  
  }

  key=getNextUnhandeledKeyRelease();
  while(key!=-1)
  {  
    sendMidiMessage(0x80, RootNote+key,0); 
    key=getNextUnhandeledKeyRelease();
  }

}



void setup() 
{

#if usesMidi
  setup_midi();
#else
  Serial.begin(9600);
#endif

  setup_button();
  setup_shiftButton();
  setup_softpots();
  setup_ButtonStates();

}

void loop() 
{
  populate_softpots();
  populate_buttons();
  checkShiftButton();
  transMitButtonsToSM();

  /*  
   printButtons();
   printpots();
   */
  if(isShift)
    run_shiftMode();
  else
  {
    if (mode==10)
      run_testMode();
    if (mode==0)
    {
      populate_softpots(); //checking this again to loos those irritating blip's that sometimes happen.
      run_guitarMode();
    }
    if (mode==1)
      run_guitarHeroMode();


  }
}



void sendMidiMessage(char cmd, char data1, char data2) 
{
  digitalWrite(ShiftLed, HIGH);

#if debugprint
  Serial.print("Skicking MIDI ");

  Serial.print(cmd,DEC);
  Serial.print(" ");
  Serial.print(data1,DEC);
  Serial.print(" ");
  Serial.println(data2,DEC);
#endif

#if usesMidi
  Serial.print(cmd, BYTE);
  Serial.print(data1, BYTE);
  Serial.print(data2, BYTE);
#endif
  digitalWrite(ShiftLed, LOW);

}

void setup_midi()
{
  Serial.begin(31250);
}



void setup_shiftButton()
{
  pinMode(shiftPin, INPUT);    // declare pushbutton as input
  pinMode(ShiftLed, OUTPUT);
  isShift = false;
  isWaitingForUp=false;
}

void checkShiftButton()
{

  int shiftButtonPressed = digitalRead(shiftPin);

  if (shiftButtonPressed == HIGH)
  {
    digitalWrite(ShiftLed, LOW);  // turn LED OFF
    isShift=false;
  } 
  else 
  {
    digitalWrite(ShiftLed, HIGH);  // turn LED ON
    isShift=true;
  }


}



void run_shiftMode()
{
  int key =0;

  key=getNextUnhandeledKeyPress();

  while(key!=-1)
  {  
#if debugprint
    Serial.print("key: ");
    Serial.println(key,DEC);
#endif

    switch (key)
    {
    case 4: //first key we get is number four in the array.
      {

#if debugprint
        Serial.print("Octave down, is now ");
        Serial.println(RootNote);
#endif
        RootNote-=12;
        break;
      }
    case 6: 
      {

#if debugprint
        Serial.print("Octave up, is now ");
        Serial.println(RootNote);
#endif
        RootNote+=12;
        break;
      }


    case 5: 
      {

#if debugprint
        Serial.print("Note down, is now ");
        Serial.println(RootNote);
#endif
        RootNote-=1;
        break;
      }
    case 7: 
      {

#if debugprint
        Serial.print("Note up, is now ");
        Serial.println(RootNote);
#endif
        RootNote+=1;
        break;
      }
    case 8: 
      {

#if debugprint
        Serial.println("Mode change to testmode");
#endif
        mode=10;
        break;
      }
    case 9: 
      {

#if debugprint
        Serial.println("Mode Change to GuitarHeroMode");
#endif
        mode=1;
        break;
      }
    case 11: 
      {
#if debugprint
        Serial.println("Mode change to Guitarmode");
#endif
        mode=0;
        break;
      }
    case 27: 
      {
#if debugprint
        Serial.println("Program change down");
#endif
        program--;
        sendMidiMessage(0xC0,program,program);  
         break;
      }
    case 28: 
      {
#if debugprint
        Serial.println("Program change up");
#endif
        program++;
       sendMidiMessage(0xC0,program,program);  
        break;
      }
  default:
      {
        break;
      }
    }

    getVelocityForKey(key);//removing this key from the stack
    key=getNextUnhandeledKeyPress();
  }




  //getting key up's to reset statemachine.
  key=getNextUnhandeledKeyRelease();
  while(key!=-1)
  {  
    key=getNextUnhandeledKeyRelease();
  }

}




void setup_softpots()
{

}

void populate_softpots()
{

  SoftPot1 = analogRead(potPin1);    // read the value from the sensor
  SoftPot2 = analogRead(potPin2);    // read the value from the sensor

}

void printpots()
{
  #if debugprint
  Serial.print(SoftPot1);        
  Serial.print(" ");       
  Serial.println(SoftPot2);      
  #endif
}


int oldTestPot1=-1;
int oldTestPot2=-1;


void run_testMode()
{
  int key;

if(SoftPot1/8 != oldTestPot1) //is ok, dont send everything always!
{
  sendMidiMessage(0xb0, 0x01 /*modwheel*/, SoftPot1/8); //8 is not a good value 8*1024=1016 , 8.062992125984252 is better
  oldTestPot1=SoftPot1/8; 
}
if(SoftPot2/8 != oldTestPot2)
{
 /* pitch bend has 0-16 .The two bytes of the pitch bend message form a 14 bit number, 0 to 1683. 
  The value 8192 (sent, LSB first, as 0x00 0x40), is centered, or "no pitch bend." The value 0 (0x00 0x00) means, 
  "bend as low as possible," and, similarly, 16383 (0x7F 0x7F) is to "bend as high as possible." The exact range of the pitch 
  bend is specific to the synthesizer. 
  */
  sendMidiMessage(0xE0, (SoftPot2/8), (SoftPot2/8)); //this is obviously not correct
  oldTestPot2=SoftPot2/8;
}

 

  key=getNextUnhandeledKeyPress();
  while(key!=-1)
  {  
    sendMidiMessage(0x90, RootNote+key,getVelocityForKey(key));
    key=getNextUnhandeledKeyPress();
  }

  key=getNextUnhandeledKeyRelease();
  while(key!=-1)
  {  
    sendMidiMessage(0x90, RootNote+key,0x0);
    key=getNextUnhandeledKeyRelease();
  }


}

int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

