
int inPin[8] = {  
  7,6,14,12,11,10,9,8  };

byte dataArray[8];

byte tempButtons[64];


void setup_button()
{

  //set pins to output because they are addressed in the main loop
  pinMode(latchPin, OUTPUT);


  dataArray[0] = B11011111; //
  dataArray[1] = B10111111;     //B10111111
  dataArray[2] = B11111101; //
  dataArray[3] = B11111011; //


  dataArray[4] = B11101111; //
  dataArray[5] = B01111111;       //B01111111
  dataArray[6] = B11111110; //
  dataArray[7] = B11110111; //




  for (int i = 0; i < 8; i++)   
  {
    pinMode(inPin[i], INPUT);
    pinMode(inPin[i], HIGH);
  }

}


void changeOn(int i)
{
  digitalWrite(latchPin, 0);
  shiftOut(dataPin, clockPin, dataArray[i]);   
  digitalWrite(latchPin, 1);

}

int readKey(int i)
{
  int val;
  pinMode(inPin[i], LOW);
  val=digitalRead(inPin[i]);

  pinMode(inPin[i], HIGH);
  return val;

}
void populate_buttons()
{
  int arne =0;
  for (int j = 0; j < 8; j++) 
  {
    changeOn(j);
  
    for (int i = 0; i < 8; i++)
    {
      int val;
      val = readKey(i);
      tempButtons[arne]=val;
      arne++;
    } 
  }


}

void printButtons()
{
  #if debugprint
  for(int i=0 ; i < 64 ; i++)
  {
    Serial.print(tempButtons[i],DEC);  
  }
  Serial.println("");    
  #endif

}

void transMitButtonsToSM()
{
  for(int i=0 ; i < 64 ; i++)
  {
    settime(i,tempButtons[i]);
  }
}

// the heart of the program
void shiftOut(int myDataPin, int myClockPin, byte myDataOut) {
  // This shifts 8 bits out MSB first, 
  //on the rising edge of the clock,
  //clock idles low

  //internal function setup
  int i=0;
  int pinState;
  pinMode(myClockPin, OUTPUT);
  pinMode(myDataPin, OUTPUT);

  //clear everything out just in case to
  //prepare shift register for bit shifting
  digitalWrite(myDataPin, 0);
  digitalWrite(myClockPin, 0);

  //for each bit in the byte myDataOut?
  //NOTICE THAT WE ARE COUNTING DOWN in our for loop
  //This means that %00000001 or "1" will go through such
  //that it will be pin Q0 that lights. 
  for (i=7; i>=0; i--)  {
    digitalWrite(myClockPin, 0);

    //if the value passed to myDataOut and a bitmask result 
    // true then... so if we are at i=6 and our value is
    // %11010100 it would the code compares it to %01000000 
    // and proceeds to set pinState to 1.
    if ( myDataOut & (1<<i) ) {
      pinState= 1;
    }
    else {	
      pinState= 0;
    }

    //Sets the pin to HIGH or LOW depending on pinState
    digitalWrite(myDataPin, pinState);
    //register shifts bits on upstroke of clock pin  
    digitalWrite(myClockPin, 1);
    //zero the data pin after shift to prevent bleed through
    digitalWrite(myDataPin, 0);
  }

  //stop shifting
  digitalWrite(myClockPin, 0);
}



