
#define IN_STATE_BR_PRESSED 1
#define IN_STATE_MR_PRESSED 2
#define IN_STATE_BR_RELELEASED 3
#define IN_STATE_MR_RELELEASED 4


#define STATE_INIT 0
#define STATE_WAITING_FOR_MR 1
#define STATE_WAITING_FOR_BR 2
#define STATE_HAS_VELOCITY 4
#define STATE_PRESSED 3
#define STATE_RELEASED 5




/* you can press the tangent and then you get first one down, then next down. when both are down you should get a velocity*/



struct buttonState
{
  long BR;
  long MR;   
  byte Velocity;
  byte State;
} 
;

buttonState buttonStates[33];

void setup_ButtonStates()
{
  for (int i=0;i<32;i++)
  {
    buttonStates[i].BR=millis();
    buttonStates[i].MR=millis();
    buttonStates[i].Velocity=0;
    buttonStates[i].State = STATE_INIT;
  }
}

void updateState(int nr,byte inState)
{
  //---------- Pressed
  if(inState == IN_STATE_BR_PRESSED)
    if(buttonStates[nr].State==STATE_INIT)
    {
      buttonStates[nr].BR=millis();
 //     Serial.print("setting BR to ");
 //     Serial.println(buttonStates[nr].BR);
  
      buttonStates[nr].State=STATE_WAITING_FOR_MR;
  //    Serial.println("setting state to STATE_WAITING_FOR_MR");
    }    
  

  if(inState == IN_STATE_MR_PRESSED )
    if(buttonStates[nr].State==STATE_WAITING_FOR_MR)
    {
      
       buttonStates[nr].MR=millis();
 //     Serial.print("setting MR to ");
 //     Serial.println(buttonStates[nr].MR);

      
      buttonStates[nr].Velocity=127-(buttonStates[nr].MR-buttonStates[nr].BR);
      if(buttonStates[nr].Velocity <= 0)
        buttonStates[nr].Velocity=1;
      if(buttonStates[nr].Velocity >= 127) //took waaaay to long time
        buttonStates[nr].Velocity=1;
        
      
      buttonStates[nr].State=STATE_HAS_VELOCITY;  
      //Serial.println("setting state to STATE_HAS_VELOCITY");
      //Serial.println("has velociy");
    /*  Serial.print("Millis: ");
      Serial.print(buttonStates[nr].BR);
      Serial.print(" ");
      Serial.print(buttonStates[nr].MR);
      Serial.print(" ");
      Serial.print(buttonStates[nr].Velocity,DEC);
      Serial.println();*/
      
    }
  //---------- EndPressed

  //---------- RELEASE
  if(buttonStates[nr].State==STATE_PRESSED)
    if(inState == IN_STATE_MR_RELELEASED)
{
  buttonStates[nr].State=STATE_WAITING_FOR_BR;
    //Serial.println("setting state to STATE_WAITING_FOR_BR");
}
  if(inState == IN_STATE_BR_RELELEASED )
    if( buttonStates[nr].State==STATE_WAITING_FOR_BR)
    {
      buttonStates[nr].State=STATE_RELEASED;  
    //  Serial.println("setting state to STATE_RELEASED");
    }
  //---------- EndRELEASE
}



int getNextUnhandeledKeyPress()
{
  for (int i=0;i<=32;i++)
    if(buttonStates[i].State ==STATE_HAS_VELOCITY)
    {
 //     Serial.print(i,DEC);
   //   Serial.println("knas");
      return i;
    }
  return -1;
}

byte getVelocityForKey(int nr)
{
  buttonStates[nr].State=STATE_PRESSED;
  //Serial.println("setting state to STATE_PRESSED");
  //Serial.print(nr,DEC);
  //Serial.println(" getting velocity");
  return buttonStates[nr].Velocity;
}

int getNextUnhandeledKeyRelease()
{
  for (int i=0;i<32;i++)
    if(buttonStates[i].State ==STATE_RELEASED)
    {
      buttonStates[i].State=STATE_INIT;
    //  Serial.println("setting state to STATE_INIT");
    //  Serial.println("getting key release");
      return i;
    }
  //Serial.println("getting No key release");
  return -1;
}

void settime(int nr,byte in_onOff)
{

  if(nr<=32)
  {
    if( in_onOff == 0)
    {
      updateState(nr,IN_STATE_BR_PRESSED);
    }
    else
    {
      buttonStates[nr].BR=0;
      updateState(nr,IN_STATE_BR_RELELEASED);
    }
  }
  else
  {
    if( in_onOff == 0)
    {
      updateState(nr-32,IN_STATE_MR_PRESSED);
    }
    else
    {
      buttonStates[nr-32].MR=0;
      updateState(nr-32,IN_STATE_MR_RELELEASED);
    }
  }


}
