

void setup_shiftButton()
{
  pinMode(shiftPin, INPUT);    // declare pushbutton as input
  pinMode(ShiftLed, OUTPUT);
  isShift = false;
  isWaitingForUp=false;
}

void checkShiftButton()
{

  int shiftButtonPressed = digitalRead(shiftPin);

  if (shiftButtonPressed == HIGH)
  {
    digitalWrite(ShiftLed, LOW);  // turn LED OFF
    isShift=false;
  } 
  else 
  {
    digitalWrite(ShiftLed, HIGH);  // turn LED ON
    isShift=true;
  }


}



void run_shiftMode()
{
  int key =0;

  key=getNextUnhandeledKeyPress();

  while(key!=-1)
  {  
#if debugprint
    Serial.print("key: ");
    Serial.println(key,DEC);
#endif

    switch (key)
    {
    case 4: //first key we get is number four in the array.
      {

#if debugprint
        Serial.print("Octave down, is now ");
        Serial.println(RootNote);
#endif
        RootNote-=12;
        break;
      }
    case 6: 
      {

#if debugprint
        Serial.print("Octave up, is now ");
        Serial.println(RootNote);
#endif
        RootNote+=12;
        break;
      }


    case 5: 
      {

#if debugprint
        Serial.print("Note down, is now ");
        Serial.println(RootNote);
#endif
        RootNote-=1;
        break;
      }
    case 7: 
      {

#if debugprint
        Serial.print("Note up, is now ");
        Serial.println(RootNote);
#endif
        RootNote+=1;
        break;
      }
    case 8: 
      {

#if debugprint
        Serial.println("Mode change to testmode");
#endif
        mode=10;
        break;
      }
    case 9: 
      {

#if debugprint
        Serial.println("Mode Change to GuitarHeroMode");
#endif
        mode=1;
        break;
      }
    case 11: 
      {
#if debugprint
        Serial.println("Mode change to Guitarmode");
#endif
        mode=0;
        break;
      }
    case 27: 
      {
#if debugprint
        Serial.println("Program change down");
#endif
        program--;
        sendMidiMessage(0xC0,program,0);  
         break;
      }
    case 28: 
      {
#if debugprint
        Serial.println("Program change down");
#endif
        program++;
       sendMidiMessage(0xC0,program,0);  
        break;
      }
  default:
      {
        break;
      }
    }

    getVelocityForKey(key);//removing this key from the stack
    key=getNextUnhandeledKeyPress();
  }




  //getting key up's to reset statemachine.
  key=getNextUnhandeledKeyRelease();
  while(key!=-1)
  {  
    key=getNextUnhandeledKeyRelease();
  }

}

